Subject: Re: [PATCH net-next] tcp: try to defer / return acked skbs to originating CPU

From: Jakub Kicinski <[email-masked]>
Date: Mon, 19 Jan 2026 09:04:35 -0800

On Sun, 18 Jan 2026 13:15:00 +0100 Eric Dumazet wrote:
> > > Also, if workers are away from softirq, they will only process the
> > > defer queue in large patches, after receiving an trigger_rx_softirq()
> > > IPI.
> > > Any idea of skb_defer_free_flush() latency when dealing with batches
> > > of ~64 big TSO packets ?  
> >
> > Not sure if there's much we can do about that.. Perhaps we should have
> > a shrinker that flushes the defer queues? I chatted with Shakeel briefly
> > and it sounded fairly straightforward.  
> 
> I was mostly concerned about latency spikes, I did some tests here and
> this seems fine.

Looks like selftests run into the zerocopy Tx latency issue.
I'll drop this version from patchwork..

> (I assume you asked Shakeel about the extra memory being held in the
> per-cpu queue, and pcp implications ?)

Under real load it helps quite a bit but real load flushes the queues
frequently. I'll talk to him.